//+------------------------------------------------------------------+
//|                                      Sort of Double Donchian.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, Dink Toan"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 OrangeRed
#property indicator_color4 Lime
#property indicator_color5 DimGray
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

input int BarsToCount=20;
input int Shift=1;

double     upper1[], lower1[];
double     upper2[], lower2[];
double     middle2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
   IndicatorShortName("Sort of Double Donchian("+IntegerToString(BarsToCount)+")");

   SetIndexBuffer(0,upper1);    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);             SetIndexLabel(0,"Upper1"); 
   SetIndexBuffer(1,lower1);    SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);             SetIndexLabel(1,"Lower1"); 
   SetIndexBuffer(2,upper2);    SetIndexStyle(2,DRAW_LINE,STYLE_DOT);               SetIndexLabel(2,"Upper2"); 
   SetIndexBuffer(3,lower2);    SetIndexStyle(3,DRAW_LINE,STYLE_DOT);               SetIndexLabel(3,"Lower2");
   SetIndexBuffer(4,middle2);   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID);             SetIndexLabel(4,"Middle1"); 
   
   //---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
   {
      int limit = rates_total - prev_calculated;
      if(prev_calculated > 0) limit++;
   
      for(int i=0; i < limit; i++)
         {
            upper1[i]=iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,BarsToCount,i+Shift));
            lower1[i]=iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,BarsToCount,i+Shift));
      
            lower2[i]=iHigh(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_HIGH,BarsToCount,i+Shift));
            upper2[i]=iLow(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_LOW,BarsToCount,i+Shift));
      
            middle2[i]=(upper2[i]+lower2[i])/2;
            }
         return(rates_total);
      }
//+------------------------------------------------------------------+
